package com.unis.basic.info.modular.unitInfo.entity;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

public class BasicEnumExample {
    /**
     * basic_enum
     */
    protected String orderByClause;

    /**
     * basic_enum
     */
    protected boolean distinct;

    /**
     * basic_enum
     */
    protected List<Criteria> oredCriteria;

    public BasicEnumExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    public String getOrderByClause() {
        return orderByClause;
    }

    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    public boolean isDistinct() {
        return distinct;
    }

    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * basic_enum 2017-11-08
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        public Criteria andEnumidIsNull() {
            addCriterion("enumId is null");
            return (Criteria) this;
        }

        public Criteria andEnumidIsNotNull() {
            addCriterion("enumId is not null");
            return (Criteria) this;
        }

        public Criteria andEnumidEqualTo(Integer value) {
            addCriterion("enumId =", value, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidNotEqualTo(Integer value) {
            addCriterion("enumId <>", value, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidGreaterThan(Integer value) {
            addCriterion("enumId >", value, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidGreaterThanOrEqualTo(Integer value) {
            addCriterion("enumId >=", value, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidLessThan(Integer value) {
            addCriterion("enumId <", value, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidLessThanOrEqualTo(Integer value) {
            addCriterion("enumId <=", value, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidIn(List<Integer> values) {
            addCriterion("enumId in", values, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidNotIn(List<Integer> values) {
            addCriterion("enumId not in", values, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidBetween(Integer value1, Integer value2) {
            addCriterion("enumId between", value1, value2, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumidNotBetween(Integer value1, Integer value2) {
            addCriterion("enumId not between", value1, value2, "enumid");
            return (Criteria) this;
        }

        public Criteria andEnumcodeIsNull() {
            addCriterion("enumCode is null");
            return (Criteria) this;
        }

        public Criteria andEnumcodeIsNotNull() {
            addCriterion("enumCode is not null");
            return (Criteria) this;
        }

        public Criteria andEnumcodeEqualTo(String value) {
            addCriterion("enumCode =", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeNotEqualTo(String value) {
            addCriterion("enumCode <>", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeGreaterThan(String value) {
            addCriterion("enumCode >", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeGreaterThanOrEqualTo(String value) {
            addCriterion("enumCode >=", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeLessThan(String value) {
            addCriterion("enumCode <", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeLessThanOrEqualTo(String value) {
            addCriterion("enumCode <=", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeLike(String value) {
            addCriterion("enumCode like", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeNotLike(String value) {
            addCriterion("enumCode not like", value, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeIn(List<String> values) {
            addCriterion("enumCode in", values, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeNotIn(List<String> values) {
            addCriterion("enumCode not in", values, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeBetween(String value1, String value2) {
            addCriterion("enumCode between", value1, value2, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumcodeNotBetween(String value1, String value2) {
            addCriterion("enumCode not between", value1, value2, "enumcode");
            return (Criteria) this;
        }

        public Criteria andEnumnameIsNull() {
            addCriterion("enumName is null");
            return (Criteria) this;
        }

        public Criteria andEnumnameIsNotNull() {
            addCriterion("enumName is not null");
            return (Criteria) this;
        }

        public Criteria andEnumnameEqualTo(String value) {
            addCriterion("enumName =", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameNotEqualTo(String value) {
            addCriterion("enumName <>", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameGreaterThan(String value) {
            addCriterion("enumName >", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameGreaterThanOrEqualTo(String value) {
            addCriterion("enumName >=", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameLessThan(String value) {
            addCriterion("enumName <", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameLessThanOrEqualTo(String value) {
            addCriterion("enumName <=", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameLike(String value) {
            addCriterion("enumName like", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameNotLike(String value) {
            addCriterion("enumName not like", value, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameIn(List<String> values) {
            addCriterion("enumName in", values, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameNotIn(List<String> values) {
            addCriterion("enumName not in", values, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameBetween(String value1, String value2) {
            addCriterion("enumName between", value1, value2, "enumname");
            return (Criteria) this;
        }

        public Criteria andEnumnameNotBetween(String value1, String value2) {
            addCriterion("enumName not between", value1, value2, "enumname");
            return (Criteria) this;
        }

        public Criteria andGbcodeIsNull() {
            addCriterion("gbCode is null");
            return (Criteria) this;
        }

        public Criteria andGbcodeIsNotNull() {
            addCriterion("gbCode is not null");
            return (Criteria) this;
        }

        public Criteria andGbcodeEqualTo(String value) {
            addCriterion("gbCode =", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeNotEqualTo(String value) {
            addCriterion("gbCode <>", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeGreaterThan(String value) {
            addCriterion("gbCode >", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeGreaterThanOrEqualTo(String value) {
            addCriterion("gbCode >=", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeLessThan(String value) {
            addCriterion("gbCode <", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeLessThanOrEqualTo(String value) {
            addCriterion("gbCode <=", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeLike(String value) {
            addCriterion("gbCode like", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeNotLike(String value) {
            addCriterion("gbCode not like", value, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeIn(List<String> values) {
            addCriterion("gbCode in", values, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeNotIn(List<String> values) {
            addCriterion("gbCode not in", values, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeBetween(String value1, String value2) {
            addCriterion("gbCode between", value1, value2, "gbcode");
            return (Criteria) this;
        }

        public Criteria andGbcodeNotBetween(String value1, String value2) {
            addCriterion("gbCode not between", value1, value2, "gbcode");
            return (Criteria) this;
        }

        public Criteria andParentidIsNull() {
            addCriterion("parentId is null");
            return (Criteria) this;
        }

        public Criteria andParentidIsNotNull() {
            addCriterion("parentId is not null");
            return (Criteria) this;
        }

        public Criteria andParentidEqualTo(Integer value) {
            addCriterion("parentId =", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotEqualTo(Integer value) {
            addCriterion("parentId <>", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidGreaterThan(Integer value) {
            addCriterion("parentId >", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidGreaterThanOrEqualTo(Integer value) {
            addCriterion("parentId >=", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLessThan(Integer value) {
            addCriterion("parentId <", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidLessThanOrEqualTo(Integer value) {
            addCriterion("parentId <=", value, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidIn(List<Integer> values) {
            addCriterion("parentId in", values, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotIn(List<Integer> values) {
            addCriterion("parentId not in", values, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidBetween(Integer value1, Integer value2) {
            addCriterion("parentId between", value1, value2, "parentid");
            return (Criteria) this;
        }

        public Criteria andParentidNotBetween(Integer value1, Integer value2) {
            addCriterion("parentId not between", value1, value2, "parentid");
            return (Criteria) this;
        }

        public Criteria andCreatedateIsNull() {
            addCriterion("createDate is null");
            return (Criteria) this;
        }

        public Criteria andCreatedateIsNotNull() {
            addCriterion("createDate is not null");
            return (Criteria) this;
        }

        public Criteria andCreatedateEqualTo(Date value) {
            addCriterion("createDate =", value, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateNotEqualTo(Date value) {
            addCriterion("createDate <>", value, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateGreaterThan(Date value) {
            addCriterion("createDate >", value, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateGreaterThanOrEqualTo(Date value) {
            addCriterion("createDate >=", value, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateLessThan(Date value) {
            addCriterion("createDate <", value, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateLessThanOrEqualTo(Date value) {
            addCriterion("createDate <=", value, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateIn(List<Date> values) {
            addCriterion("createDate in", values, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateNotIn(List<Date> values) {
            addCriterion("createDate not in", values, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateBetween(Date value1, Date value2) {
            addCriterion("createDate between", value1, value2, "createdate");
            return (Criteria) this;
        }

        public Criteria andCreatedateNotBetween(Date value1, Date value2) {
            addCriterion("createDate not between", value1, value2, "createdate");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("remark is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("remark is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("remark =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("remark <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("remark >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("remark >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("remark <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("remark <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("remark like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("remark not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("remark in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("remark not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("remark between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("remark not between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andDelflagIsNull() {
            addCriterion("delFlag is null");
            return (Criteria) this;
        }

        public Criteria andDelflagIsNotNull() {
            addCriterion("delFlag is not null");
            return (Criteria) this;
        }

        public Criteria andDelflagEqualTo(Integer value) {
            addCriterion("delFlag =", value, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagNotEqualTo(Integer value) {
            addCriterion("delFlag <>", value, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagGreaterThan(Integer value) {
            addCriterion("delFlag >", value, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagGreaterThanOrEqualTo(Integer value) {
            addCriterion("delFlag >=", value, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagLessThan(Integer value) {
            addCriterion("delFlag <", value, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagLessThanOrEqualTo(Integer value) {
            addCriterion("delFlag <=", value, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagIn(List<Integer> values) {
            addCriterion("delFlag in", values, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagNotIn(List<Integer> values) {
            addCriterion("delFlag not in", values, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagBetween(Integer value1, Integer value2) {
            addCriterion("delFlag between", value1, value2, "delflag");
            return (Criteria) this;
        }

        public Criteria andDelflagNotBetween(Integer value1, Integer value2) {
            addCriterion("delFlag not between", value1, value2, "delflag");
            return (Criteria) this;
        }
    }

    /**
     * basic_enum
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * basic_enum 2017-11-08
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}